<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\MVoting;

/**
 * MVotingSearch represents the model behind the search form of `app\models\MVoting`.
 */
class MVotingSearch extends MVoting
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_voting'], 'integer'],
            [['nama_voting', 'periode_awal', 'periode_tutup'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = MVoting::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id_voting' => $this->id_voting,
            'periode_awal' => $this->periode_awal,
            'periode_tutup' => $this->periode_tutup,
        ]);

        $query->andFilterWhere(['like', 'nama_voting', $this->nama_voting]);

        return $dataProvider;
    }
}
